static const char file_id[] = "ACSAddFixSim.pl";
// .cc file generated from ACSAddFixSim.pl by ptlang
/*
Copyright (c) 1998 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "ACSAddFixSim.h"
#include "ACSAdd.h"

const char *star_nm_ACSAddFixSim = "ACSAddFixSim";

const char* ACSAddFixSim :: className() const {return star_nm_ACSAddFixSim;}

ISA_FUNC(ACSAddFixSim,ACSFixSimCore);

ACSCore* ACSAddFixSim :: makeNew( ACSCorona & corona_) const { LOG_NEW; return new ACSAddFixSim(corona_); }

ACSAddFixSim::ACSAddFixSim ( ACSCorona & corona_) : ACSFixSimCore(corona_), corona((ACSAdd&)corona_)
{
	setDescriptor("Output the product of the inputs, as a floating-point value.");
	addState(OutputPrecision.setState("OutputPrecision",this,"2.14","Precision of the output in bits.\nThis is the precision that will hold the result of the arithmetic operation\non the inputs.\nWhen the value of the product extends outside of the precision,\nthe OverflowHandler will be called."));
	addState(ArrivingPrecision.setState("ArrivingPrecision",this,"YES","Flag that indicates whether or not to keep the precision of the arriving\nparticles as is:  YES keeps the same precision, and NO casts them to the\nprecision specified by the parameter \"InputPrecision\"."));
	addState(InputPrecision.setState("InputPrecision",this,"2.14","Precision of the input in bits.\nThe input particles are only cast to this precision if the\nparameter \"ArrivingPrecision\" is set to NO."));


}

void ACSAddFixSim::setup() {
# line 51 "ACSAddFixSim.pl"
ACSFixSimCore::setup();

                if ( ! int(ArrivingPrecision) ) {
		  fixIn = Fix( ((const char *) InputPrecision) );
		  if ( fixIn.invalid() )
		    Error::abortRun( *this, "Invalid InputPrecision" );
		}
		fixIn.set_rounding( int(RoundFix) );

		sum = Fix( ((const char *) OutputPrecision) );
		if ( sum.invalid() )
		  Error::abortRun( *this, "Invalid OutputPrecision" );
		sum.set_ovflow( ((const char *) OverflowHandler) );
		if ( sum.invalid() )
		  Error::abortRun( *this, "Invalid OverflowHandler" );
		sum.set_rounding( int(RoundFix) );
}

void ACSAddFixSim::go() {
# line 69 "ACSAddFixSim.pl"
MPHIter nexti(corona.input);
                PortHole *p;
		// Fixed-point class in Ptolemy 0.5 can always represent 0.0
		sum.setToZero();	// set to zero and clear error bits
                while ((p = nexti++) != 0) {
		  // We use a temporary variable to avoid gcc2.7.2/2.8 problems
		  Fix tmpsum = (*p)%0;
                  if ( int(ArrivingPrecision) )
                    sum += tmpsum;
		  else {
                    fixIn = tmpsum;
                    sum += fixIn;
		  }
		  checkOverflow(sum);
		}
                corona.output%0 << sum;
}

// Core prototype instance for known block list
static ACSAdd dummy;
static ACSAddFixSim proto(dummy);
static RegisterBlock registerBlock(proto,"AddFixSim");
