static const char file_id[] = "ACSCosFixSim.pl";
// .cc file generated from ACSCosFixSim.pl by ptlang
/*
Copyright (c) 1998 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "ACSCosFixSim.h"
#include "ACSCos.h"
#include <math.h>

const char *star_nm_ACSCosFixSim = "ACSCosFixSim";

const char* ACSCosFixSim :: className() const {return star_nm_ACSCosFixSim;}

ISA_FUNC(ACSCosFixSim,ACSFixSimCore);

ACSCore* ACSCosFixSim :: makeNew( ACSCorona & corona_) const { LOG_NEW; return new ACSCosFixSim(corona_); }

ACSCosFixSim::ACSCosFixSim ( ACSCorona & corona_) : ACSFixSimCore(corona_), corona((ACSCos&)corona_)
{
	setDescriptor("This star computes the cosine of its input, assumed to be an angle in radians.");
	addState(OutputPrecision.setState("OutputPrecision",this,"2.14","Precision of the output in bits.\nThis is the precision that will hold the result of the arithmetic operation\non the inputs.\nWhen the value of the product extends outside of the precision,\nthe OverflowHandler will be called."));
	addState(ArrivingPrecision.setState("ArrivingPrecision",this,"YES","Flag indicated whether or not to use the arriving particles as they are:\nYES keeps the same precision, and NO casts them to the\nprecision specified by the parameter \"InputPrecision\"."));
	addState(InputPrecision.setState("InputPrecision",this,"2.14","Precision of the input in bits.  The input particles are only cast\nto this precision if the parameter \"ArrivingPrecision\" is set to NO."));


}

void ACSCosFixSim::setup() {
# line 49 "ACSCosFixSim.pl"
ACSFixSimCore::setup();

                if ( ! int(ArrivingPrecision) ) {
                  fixIn = Fix( ((const char *) InputPrecision) );
		  if ( fixIn.invalid() )
		    Error::abortRun( *this, "Invalid InputPrecision" );
		}
		fixIn.set_rounding( int(RoundFix) );

                out = Fix( ((const char *) OutputPrecision) );
		if ( out.invalid() )
		  Error::abortRun( *this, "Invalid OutputPrecision" );
                out.set_ovflow( ((const char *) OverflowHandler) );
		if ( out.invalid() )
		  Error::abortRun( *this, "Invalid OverflowHandler" );
		out.set_rounding( int(RoundFix) );
}

void ACSCosFixSim::go() {
# line 68 "ACSCosFixSim.pl"
Fix tmp = corona.input%0;
		if ( int(ArrivingPrecision) ) {
			out = Fix(cos (double(tmp)));
		} else {
			fixIn = tmp;
			out = Fix(cos (double(fixIn)));
		}
		checkOverflow(out);
		corona.output%0 << out;
}

// Core prototype instance for known block list
static ACSCos dummy;
static ACSCosFixSim proto(dummy);
static RegisterBlock registerBlock(proto,"CosFixSim");
