static const char file_id[] = "ACSGainFixSim.pl";
// .cc file generated from ACSGainFixSim.pl by ptlang
/*
Copyright (c) 1998 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "ACSGainFixSim.h"
#include "ACSGain.h"

const char *star_nm_ACSGainFixSim = "ACSGainFixSim";

const char* ACSGainFixSim :: className() const {return star_nm_ACSGainFixSim;}

ISA_FUNC(ACSGainFixSim,ACSFixSimCore);

ACSCore* ACSGainFixSim :: makeNew( ACSCorona & corona_) const { LOG_NEW; return new ACSGainFixSim(corona_); }

ACSGainFixSim::ACSGainFixSim ( ACSCorona & corona_) : ACSFixSimCore(corona_), corona((ACSGain&)corona_)
{
	setDescriptor("This is an amplifier; the output is the input multiplied by the \"gain\" (default 1.0).");
	addState(fgain.setState("fgain",this,"1.0","Gain of the star."));
	addState(OutputPrecision.setState("OutputPrecision",this,"2.14","Precision of the output in bits.\nThis is the precision that will hold the result of the arithmetic operation\non the inputs.\nWhen the value of the product extends outside of the precision,\nthe OverflowHandler will be called."));
	addState(ArrivingPrecision.setState("ArrivingPrecision",this,"YES","Flag indicated whether or not to use the arriving particles as they are:\nYES keeps the same precision, and NO casts them to the\nprecision specified by the parameter \"InputPrecision\"."));
	addState(InputPrecision.setState("InputPrecision",this,"2.14","Precision of the input in bits.  The input particles are only cast\nto this precision if the parameter \"ArrivingPrecision\" is set to NO."));


}

void ACSGainFixSim::setup() {
# line 56 "ACSGainFixSim.pl"
ACSFixSimCore::setup();

                if ( ! int(ArrivingPrecision) ) {
                  fixIn = Fix( ((const char *) InputPrecision) );
		  if ( fixIn.invalid() )
		    Error::abortRun( *this, "Invalid InputPrecision" );
		}
		fixIn.set_rounding( int(RoundFix) );


                out = Fix( ((const char *) OutputPrecision) );
		if ( out.invalid() )
		  Error::abortRun( *this, "Invalid OutputPrecision" );
                out.set_ovflow( ((const char *) "saturate") );
		if ( out.invalid() )
		  Error::abortRun( *this, "Invalid OverflowHandler" );
		out.set_rounding( int(TRUE) );
}

void ACSGainFixSim::go() {
# line 75 "ACSGainFixSim.pl"
// We use a temporary variable to avoid gcc2.7.2/2.8 problems
		Fix tmpgain = corona.input%0;
		// all computations should be performed with out since that
		// is the Fix variable with the desired overflow handler
		out = Fix(fgain);
		if ( int(ArrivingPrecision) ) {
                  out *= tmpgain;
		}
		else {
                  fixIn = tmpgain;
                  out *= fixIn;
		}
		checkOverflow(out);
		corona.output%0 << out;
}

// Core prototype instance for known block list
static ACSGain dummy;
static ACSGainFixSim proto(dummy);
static RegisterBlock registerBlock(proto,"GainFixSim");
