static const char file_id[] = "ACSImpulse.pl";
// .cc file generated from ACSImpulse.pl by ptlang
/*
Copyright (c) 1998 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "ACSImpulse.h"

const char *star_nm_ACSImpulse = "ACSImpulse";

const char *src_dir_ACSImpulse = "/users/ptolemy/src/domains/acs";

const char* ACSImpulse :: getSrcDirectory() const { return src_dir_ACSImpulse; }

const char* ACSImpulse :: className() const { ACSCorona* ptr = (ACSCorona* )this; if ( initCoreFlag == 0 ) ptr->addCores(); return star_nm_ACSImpulse;}

ISA_FUNC(ACSImpulse,ACSCorona);

Block* ACSImpulse :: makeNew() const { LOG_NEW; return new ACSImpulse(1);}

ACSImpulse::ACSImpulse (int doCoreInitFlag) : ACSCorona(0)
{
	setDescriptor("Generate a single impulse or an impulse train.  By default, the\nimpulse(s) have unity amplitude.  If \"period\" (default 0) is equal to\nzero 0, then only a single impulse is generated; otherwise, it\nspecifies the period of the impulse train.  The impulse or impulse\ntrain is delayed by the amount specified by \"delay\".");
	addPort(output.setPort("output",this,FLOAT));
	addState(period.setState("period",this,"0","The period of the impulse train, 0 = aperiodic."));
	addState(delay.setState("delay",this,"0","Output will be delayed by this amount (delay must be\n        non-negative)"));
	addState(count.setState("count",this,"0","An internal state.",
# line 43 "ACSImpulse.pl"
A_NONCONSTANT|A_NONSETTABLE));



	if (doCoreInitFlag == 1 ) addCores();
}

void ACSImpulse::setup() {
# line 46 "ACSImpulse.pl"
if (int(period) < 0) {
	  Error::abortRun(*this, "Period must be non-negative");
	}
	if (int(delay) < 0) {
	  Error::abortRun(*this, "Delay must be non-negative");
	}
	if (int(period) == 0) {
	    count = - int(delay);
	}
	else {
	    count = - (int(delay)%int(period));
	}
}

// Corona prototype instance for known block list
static ACSImpulse proto;
static RegisterBlock registerBlock(proto,"Impulse");
