static const char file_id[] = "ACSImpulseFPCGC.pl";
// .cc file generated from ACSImpulseFPCGC.pl by ptlang
/*
Copyright (c) 1998 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "ACSImpulseFPCGC.h"
#include "ACSImpulse.h"

const char *star_nm_ACSImpulseFPCGC = "ACSImpulseFPCGC";

const char* ACSImpulseFPCGC :: className() const {return star_nm_ACSImpulseFPCGC;}

ISA_FUNC(ACSImpulseFPCGC,ACSFPCGCCore);

ACSCore* ACSImpulseFPCGC :: makeNew( ACSCorona & corona_) const { LOG_NEW; return new ACSImpulseFPCGC(corona_); }

CodeBlock ACSImpulseFPCGC :: init (
# line 23 "ACSImpulseFPCGC.pl"
"	/* If count != 0, then output 0.0 else output \"level\" */\n"
"	/* Increment count */\n"
"	$ref(output) = ($ref(count)++) ? 0.0 : $val(level);\n");

CodeBlock ACSImpulseFPCGC :: periodic (
# line 29 "ACSImpulseFPCGC.pl"
"	/* Reset the counter to zero if one period has elapsed */\n"
"	if ($ref(count) >= $val(period)) $ref(count) = 0;\n");

ACSImpulseFPCGC::ACSImpulseFPCGC ( ACSCorona & corona_) : ACSFPCGCCore(corona_), corona((ACSImpulse&)corona_)
{
	setDescriptor("Generate a single impulse or an impulse train.  By default, the\nimpulse(s) have unity (1.0) amplitude.  If \"period\" (default 0) is\nequal to zero 0, then only a single impulse is generated; otherwise,\nit specifies the period of the impulse train.  The impulse or impulse\ntrain is delayed by the amount specified by \"delay\".");


}

void ACSImpulseFPCGC::go() {
# line 35 "ACSImpulseFPCGC.pl"
addCode(init);
	if (int(corona.period) > 0) addCode(periodic);
}

// Core prototype instance for known block list
static ACSImpulse dummy;
static ACSImpulseFPCGC proto(dummy);
static RegisterBlock registerBlock(proto,"ImpulseFPCGC");
