static const char file_id[] = "ACSImpulseFPSim.pl";
// .cc file generated from ACSImpulseFPSim.pl by ptlang
/*
Copyright (c) 1998 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "ACSImpulseFPSim.h"
#include "ACSImpulse.h"

const char *star_nm_ACSImpulseFPSim = "ACSImpulseFPSim";

const char* ACSImpulseFPSim :: className() const {return star_nm_ACSImpulseFPSim;}

ISA_FUNC(ACSImpulseFPSim,ACSFPSimCore);

ACSCore* ACSImpulseFPSim :: makeNew( ACSCorona & corona_) const { LOG_NEW; return new ACSImpulseFPSim(corona_); }

ACSImpulseFPSim::ACSImpulseFPSim ( ACSCorona & corona_) : ACSFPSimCore(corona_), corona((ACSImpulse&)corona_)
{
	setDescriptor("Generate a single impulse or an impulse train.  By default, the\nimpulse(s) have unity (1.0) amplitude.  If \"period\" (default 0) is\nequal to zero 0, then only a single impulse is generated; otherwise,\nit specifies the period of the impulse train.  The impulse or impulse\ntrain is delayed by the amount specified by \"delay\".");
	addState(level.setState("level",this,"1.0","The height of the impulse(s)."));


}

void ACSImpulseFPSim::go() {
# line 29 "ACSImpulseFPSim.pl"
double t = 0.0;
	if (int(corona.count) == 0) t = level;
	corona.count = int(corona.count) + 1;
	if (int(corona.period) > 0 && int(corona.count) >= int(corona.period)) corona.count = 0;
	corona.output%0 << t;
}

// Core prototype instance for known block list
static ACSImpulse dummy;
static ACSImpulseFPSim proto(dummy);
static RegisterBlock registerBlock(proto,"ImpulseFPSim");
