static const char file_id[] = "ACSImpulseFixSim.pl";
// .cc file generated from ACSImpulseFixSim.pl by ptlang
/*
Copyright (c) 1998 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "ACSImpulseFixSim.h"
#include "ACSImpulse.h"

const char *star_nm_ACSImpulseFixSim = "ACSImpulseFixSim";

const char* ACSImpulseFixSim :: className() const {return star_nm_ACSImpulseFixSim;}

ISA_FUNC(ACSImpulseFixSim,ACSFixSimCore);

ACSCore* ACSImpulseFixSim :: makeNew( ACSCorona & corona_) const { LOG_NEW; return new ACSImpulseFixSim(corona_); }

ACSImpulseFixSim::ACSImpulseFixSim ( ACSCorona & corona_) : ACSFixSimCore(corona_), corona((ACSImpulse&)corona_)
{
	setDescriptor("Generate a single impulse or an impulse train.  By default, the\nimpulse(s) have unity (1) amplitude.  If \"period\" (default 0) is\nequal to zero 0, then only a single impulse is generated; otherwise,\nit specifies the period of the impulse train.  The impulse or impulse\ntrain is delayed by the amount specified by \"delay\".");
	addState(fixLevel.setState("fixLevel",this,"1.0","The height of the impulse(s)."));
	addState(OutputPrecision.setState("OutputPrecision",this,"2.14","Impulse(s) will have height with specified precision."));


}

void ACSImpulseFixSim::setup() {
# line 41 "ACSImpulseFixSim.pl"
out = Fix( ((const char *) OutputPrecision) );
	if ( out.invalid() )
	  Error::abortRun( *this, "Invalid OutputPrecision" );
	out.set_ovflow( ((const char *) OverflowHandler) );
	if ( out.invalid() )
	  Error::abortRun( *this, "Invalid OverflowHandler" );
	out.set_rounding( int(RoundFix) );
}

void ACSImpulseFixSim::go() {
# line 50 "ACSImpulseFixSim.pl"
out = 0.0;
	if (int(corona.count) == 0) out = Fix(fixLevel);
	corona.count = int(corona.count) + 1;
	if (int(corona.period) > 0 && int(corona.count) >= int(corona.period)) corona.count = 0;
	corona.output%0 << out;
}

// Core prototype instance for known block list
static ACSImpulse dummy;
static ACSImpulseFixSim proto(dummy);
static RegisterBlock registerBlock(proto,"ImpulseFixSim");
