static const char file_id[] = "ACSMpyFixSim.pl";
// .cc file generated from ACSMpyFixSim.pl by ptlang
/*
Copyright (c) 1998 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "ACSMpyFixSim.h"
#include "ACSMpy.h"

const char *star_nm_ACSMpyFixSim = "ACSMpyFixSim";

const char* ACSMpyFixSim :: className() const {return star_nm_ACSMpyFixSim;}

ISA_FUNC(ACSMpyFixSim,ACSFixSimCore);

ACSCore* ACSMpyFixSim :: makeNew( ACSCorona & corona_) const { LOG_NEW; return new ACSMpyFixSim(corona_); }

ACSMpyFixSim::ACSMpyFixSim ( ACSCorona & corona_) : ACSFixSimCore(corona_), corona((ACSMpy&)corona_)
{
	setDescriptor("Output the product of the inputs, as a floating-point value.");
	addState(OutputPrecision.setState("OutputPrecision",this,"2.14","Precision of the output in bits.\nThis is the precision that will hold the result of the arithmetic operation\non the inputs.\nWhen the value of the product extends outside of the precision,\nthe OverflowHandler will be called."));
	addState(ArrivingPrecision.setState("ArrivingPrecision",this,"YES","Indicates whether or not to keep the precision of the arriving particles\nas they are:  YES keeps the same precision, and NO casts the inputs\nto the precision specified by the parameter \"InputPrecision\"."));
	addState(InputPrecision.setState("InputPrecision",this,"2.14","Sets the precision of the input in bits.\nThe input particles are only cast to this precision if the\nparameter \"ArrivingPrecision\" is set to NO."));


}

void ACSMpyFixSim::setup() {
# line 52 "ACSMpyFixSim.pl"
ACSFixSimCore::setup();

		if ( ! int(ArrivingPrecision) ) {
		  fixIn = Fix( ((const char *) InputPrecision) );
		  if ( fixIn.invalid() )
		    Error::abortRun( *this, "Invalid InputPrecision" );
		}
		fixIn.set_rounding( int(RoundFix) );

	        product = Fix( ((const char *) OutputPrecision) );
		if ( product.invalid() )
		  Error::abortRun( *this, "Invalid OutputPrecision" );
	        product.set_ovflow( ((const char *) OverflowHandler) );
		if ( product.invalid() )
		  Error::abortRun( *this, "Invalid OverflowHandler" );
		product.set_rounding( int(RoundFix) );
}

void ACSMpyFixSim::go() {
# line 70 "ACSMpyFixSim.pl"
MPHIter nexti(corona.input);
	        PortHole *p;

		// initialize product as the value on the first input port
		// (if it exists) and then compute the product
		p = nexti++;
		if ( p != 0 ) {
		  // We use a temporary variable to avoid gcc2.7.2/2.8 problems
		  Fix tmpproduct = (*p)%0;
	          fixIn = tmpproduct;
	          product = fixIn;
		  checkOverflow(product);
	          while ((p = nexti++) != 0) {
	            Fix tmpproduct2 = (*p)%0;	
		    if ( int(ArrivingPrecision) )
		      product *= tmpproduct2;
		    else {
	              fixIn = tmpproduct2;
		      product *= fixIn;
		    }
		    checkOverflow(product);
		  }
		}
		else {
		  product = 1.0;	   // 1.0 will overflow if the fixed-
		  checkOverflow(product);  // representation has 0 integer bits
		}
	        corona.output%0 << product;
}

// Core prototype instance for known block list
static ACSMpy dummy;
static ACSMpyFixSim proto(dummy);
static RegisterBlock registerBlock(proto,"MpyFixSim");
