static const char file_id[] = "ACSPolarToRectFixSim.pl";
// .cc file generated from ACSPolarToRectFixSim.pl by ptlang
/*
Copyright (c) 1998 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "ACSPolarToRectFixSim.h"
#include "ACSPolarToRect.h"
#include <math.h>

const char *star_nm_ACSPolarToRectFixSim = "ACSPolarToRectFixSim";

const char* ACSPolarToRectFixSim :: className() const {return star_nm_ACSPolarToRectFixSim;}

ISA_FUNC(ACSPolarToRectFixSim,ACSFixSimCore);

ACSCore* ACSPolarToRectFixSim :: makeNew( ACSCorona & corona_) const { LOG_NEW; return new ACSPolarToRectFixSim(corona_); }

ACSPolarToRectFixSim::ACSPolarToRectFixSim ( ACSCorona & corona_) : ACSFixSimCore(corona_), corona((ACSPolarToRect&)corona_)
{
	setDescriptor("Convert magnitude and phase to rectangular form.");
	addState(OutputPrecision.setState("OutputPrecision",this,"2.14","Precision of the output in bits.\nThis is the precision that will hold the result of the arithmetic operation\non the inputs.\nWhen the value of the product extends outside of the precision,\nthe OverflowHandler will be called."));
	addState(ArrivingPrecision.setState("ArrivingPrecision",this,"YES","Indicates whether or not to keep the precision of the arriving particles\nas they are:  YES keeps the same precision, and NO casts the inputs\nto the precision specified by the parameter \"InputPrecision\"."));
	addState(InputPrecision.setState("InputPrecision",this,"2.14","Sets the precision of the input in bits.\nThe input particles are only cast to this precision if the\nparameter \"ArrivingPrecision\" is set to NO."));


}

void ACSPolarToRectFixSim::setup() {
# line 52 "ACSPolarToRectFixSim.pl"
ACSFixSimCore::setup();

		if ( ! int(ArrivingPrecision) ) {
		  fixIn = Fix( ((const char *) InputPrecision) );
		  if ( fixIn.invalid() )
		    Error::abortRun( *this, "Invalid InputPrecision" );
		}
		fixIn.set_rounding( int(RoundFix) );

                out = Fix( ((const char *) OutputPrecision) );
		if ( out.invalid() )
		  Error::abortRun( *this, "Invalid OutputPrecision" );
                out.set_ovflow( ((const char *) OverflowHandler) );
		if ( out.invalid() )
		  Error::abortRun( *this, "Invalid OverflowHandler" );
		out.set_rounding( int(RoundFix) );
}

void ACSPolarToRectFixSim::go() {
# line 71 "ACSPolarToRectFixSim.pl"
Fix m = corona.magnitude%0;
		Fix p = corona.phase%0;
		if ( int(ArrivingPrecision) ) {
			out =  Fix(double(m) * cos(double(p)));
			checkOverflow(out);
			corona.x%0 << double(out);
			out = Fix(double(m) * sin(double(p)));
			checkOverflow(out);
			corona.y%0 << double(out);
		} else {
			fixIn = p;
			double tmp = cos(double(fixIn));
			fixIn = m;
			out = Fix(double(m) * tmp);
			checkOverflow(out);
			corona.x%0 << double(out);
			fixIn = p;
			tmp = sin(double(fixIn));
			fixIn = m;
			out = Fix(double(m) * tmp);
			checkOverflow(out);
			corona.y%0 << double(out);
		}
}

// Core prototype instance for known block list
static ACSPolarToRect dummy;
static ACSPolarToRectFixSim proto(dummy);
static RegisterBlock registerBlock(proto,"PolarToRectFixSim");
