static const char file_id[] = "ACSPrinterFPCGC.pl";
// .cc file generated from ACSPrinterFPCGC.pl by ptlang
/*
Copyright (c) 1998 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "ACSPrinterFPCGC.h"
#include "ACSPrinter.h"

const char *star_nm_ACSPrinterFPCGC = "ACSPrinterFPCGC";

const char* ACSPrinterFPCGC :: className() const {return star_nm_ACSPrinterFPCGC;}

ISA_FUNC(ACSPrinterFPCGC,ACSFPCGCCore);

ACSCore* ACSPrinterFPCGC :: makeNew( ACSCorona & corona_) const { LOG_NEW; return new ACSPrinterFPCGC(corona_); }

ACSPrinterFPCGC::ACSPrinterFPCGC ( ACSCorona & corona_) : ACSFPCGCCore(corona_), corona((ACSPrinter&)corona_)
{
	setDescriptor("Prints out one sample from each input port per line.\nIf \"fileName\" is not equal to \"cout\" (the default) or \"stdout\", it\nspecifies the filename to write to.");
	addState(fileNameCGC.setState("fileNameCGC",this,"<stdout>","Filename for output."));
	addState(index.setState("index",this,"1","index for multi input trace.",
# line 29 "ACSPrinterFPCGC.pl"
A_NONSETTABLE|A_NONCONSTANT));


}

int ACSPrinterFPCGC::myExecTime() {
# line 78 "ACSPrinterFPCGC.pl"
return 6;       /* unmeasured value */
}

void ACSPrinterFPCGC::wrapup() {
# line 74 "ACSPrinterFPCGC.pl"
if(fileOutput)
	addCode("\tfclose($starSymbol(fp));\n");
}

void ACSPrinterFPCGC::initCode() {
# line 36 "ACSPrinterFPCGC.pl"
const char *fn = fileNameCGC;
      fileOutput = ! ( fn==NULL
		       || strcmp(fn, "cout")==0 || strcmp(fn, "stdout")==0
		       || strcmp(fn, "<cout>")==0 || strcmp(fn, "<stdout>")==0);
      if(fileOutput) {
	StringList s;
	s << "    FILE* $starSymbol(fp);";
	addDeclaration(s);
	addInclude("<stdio.h>");
	expandedFileName = expandPathName(fn);
	s = "\tif(!($starSymbol(fp)=fopen(\"";
	s << expandedFileName << "\",\"w\"))) {\n";
	s << "\t\tfprintf(stderr,\"ERROR: cannot open output file for Printer star.\n\");\n";
	s << "\t\texit(1);\n";
	s << "\t}\n";
	addCode(s);
      }
}

void ACSPrinterFPCGC::go() {
# line 55 "ACSPrinterFPCGC.pl"
for (int i = 1; i <= corona.input.numberPorts(); i++)
	{
	  index = i;
	  if(fileOutput) {
	    addCode("\tfprintf($starSymbol(fp),\"%f\\t\", (double) ($ref(input#index)));\n");
	  } 
	  else
	    {
	    addCode("\tprintf(\"%f\\t\", (double) ($ref(input#index)));\n");
	  }
	}
      if (fileOutput) {
	addCode("\tfprintf($starSymbol(fp),\"\\n\");\n");
      } 
      else {
	addCode("\tprintf(\"\\n\");\n");
      }
}

// Core prototype instance for known block list
static ACSPrinter dummy;
static ACSPrinterFPCGC proto(dummy);
static RegisterBlock registerBlock(proto,"PrinterFPCGC");
