static const char file_id[] = "ACSPrinterFixSim.pl";
// .cc file generated from ACSPrinterFixSim.pl by ptlang
/*
Copyright (c) 1998 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "ACSPrinterFixSim.h"
#include "ACSPrinter.h"

const char *star_nm_ACSPrinterFixSim = "ACSPrinterFixSim";

const char* ACSPrinterFixSim :: className() const {return star_nm_ACSPrinterFixSim;}

ISA_FUNC(ACSPrinterFixSim,ACSFixSimCore);

ACSCore* ACSPrinterFixSim :: makeNew( ACSCorona & corona_) const { LOG_NEW; return new ACSPrinterFixSim(corona_); }

ACSPrinterFixSim::ACSPrinterFixSim ( ACSCorona & corona_) : ACSFixSimCore(corona_), corona((ACSPrinter&)corona_)
{
	setDescriptor("Print out one sample from each input port per line.  The \"fileName\"\nstate specifies the file to be written; the special names\n&lt;stdout&gt; and &lt;cout&gt;, which specify the standard output\nstream, and &lt;stderr&gt; and &lt;cerr&gt;, which specify the\nstandard error stream, are also supported.");
	addState(fileNameFix.setState("fileNameFix",this,"<stdout>","Filename for output."));

# line 32 "ACSPrinterFixSim.pl"
p_out = 0;
}

void ACSPrinterFixSim::wrapup() {
# line 48 "ACSPrinterFixSim.pl"
LOG_DEL; delete p_out;		// flush output
		p_out = 0;
}

ACSPrinterFixSim::~ACSPrinterFixSim() {
# line 52 "ACSPrinterFixSim.pl"
LOG_DEL; delete p_out;		// flush output
}

void ACSPrinterFixSim::setup() {
# line 35 "ACSPrinterFixSim.pl"
// in case file was open from previous run w/o wrapup call
		LOG_DEL; delete p_out;
		LOG_NEW; p_out = new pt_ofstream(fileNameFix);
}

void ACSPrinterFixSim::go() {
# line 40 "ACSPrinterFixSim.pl"
pt_ofstream& output = *p_out;
		MPHIter nexti(corona.input);
		PortHole* p;
		while ((p = nexti++) != 0)
		 	output << ((*p)%0).print() << "\t";
		output << "\n";
}

// Core prototype instance for known block list
static ACSPrinter dummy;
static ACSPrinterFixSim proto(dummy);
static RegisterBlock registerBlock(proto,"PrinterFixSim");
