static const char file_id[] = "ACSRampFixSim.pl";
// .cc file generated from ACSRampFixSim.pl by ptlang
/*
Copyright (c) 1998 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "ACSRampFixSim.h"
#include "ACSRamp.h"

const char *star_nm_ACSRampFixSim = "ACSRampFixSim";

const char* ACSRampFixSim :: className() const {return star_nm_ACSRampFixSim;}

ISA_FUNC(ACSRampFixSim,ACSFixSimCore);

ACSCore* ACSRampFixSim :: makeNew( ACSCorona & corona_) const { LOG_NEW; return new ACSRampFixSim(corona_); }

ACSRampFixSim::ACSRampFixSim ( ACSCorona & corona_) : ACSFixSimCore(corona_), corona((ACSRamp&)corona_)
{
	setDescriptor("Generate a ramp signal, starting at \"value\" (default 0) and\nincrementing by step size \"step\" (default 1) on each firing.");
	addState(fstep.setState("fstep",this,"1.0","Increment from one sample to the next."));
	addState(fvalue.setState("fvalue",this,"0.0","Initial (or latest) value output by Ramp.",
# line 30 "ACSRampFixSim.pl"
A_SETTABLE | A_NONCONSTANT));
	addState(OutputPrecision.setState("OutputPrecision",this,"2.14","Precision of the output in bits and precision of the accumulation.\nWhen the value of the accumulation extends outside of the precision,\nthe OverflowHandler will be called."));


}

void ACSRampFixSim::setup() {
# line 46 "ACSRampFixSim.pl"
t = Fix( ((const char *) OutputPrecision) );
		if ( t.invalid() )
		  Error::abortRun( *this, "Invalid OutputPrecision" );
                t.set_ovflow( ((const char *) OverflowHandler) );
		if ( t.invalid() )
		   Error::abortRun( *this, "Invalid OverflowHandler" );
		t.set_rounding( int(RoundFix) );
}

void ACSRampFixSim::go() {
# line 55 "ACSRampFixSim.pl"
t = Fix(fvalue);
		corona.output%0 << t;
		t += Fix(fstep);
		fvalue = t;
}

// Core prototype instance for known block list
static ACSRamp dummy;
static ACSRampFixSim proto(dummy);
static RegisterBlock registerBlock(proto,"RampFixSim");
