static const char file_id[] = "ACSSinFixSim.pl";
// .cc file generated from ACSSinFixSim.pl by ptlang
/*
Copyright (c) 1998 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "ACSSinFixSim.h"
#include "ACSSin.h"
#include <math.h>

const char *star_nm_ACSSinFixSim = "ACSSinFixSim";

const char* ACSSinFixSim :: className() const {return star_nm_ACSSinFixSim;}

ISA_FUNC(ACSSinFixSim,ACSFixSimCore);

ACSCore* ACSSinFixSim :: makeNew( ACSCorona & corona_) const { LOG_NEW; return new ACSSinFixSim(corona_); }

ACSSinFixSim::ACSSinFixSim ( ACSCorona & corona_) : ACSFixSimCore(corona_), corona((ACSSin&)corona_)
{
	setDescriptor("This star computes the sine of its input, assumed to be an angle in radians.");
	addState(OutputPrecision.setState("OutputPrecision",this,"2.14","Precision of the output in bits.\nThis is the precision that will hold the result of the arithmetic operation\non the inputs.\nWhen the value of the product extends outside of the precision,\nthe OverflowHandler will be called."));
	addState(ArrivingPrecision.setState("ArrivingPrecision",this,"YES","Flag indicated whether or not to use the arriving particles as they are:\nYES keeps the same precision, and NO casts them to the\nprecision specified by the parameter \"InputPrecision\"."));
	addState(InputPrecision.setState("InputPrecision",this,"2.14","Precision of the input in bits.  The input particles are only cast\nto this precision if the parameter \"ArrivingPrecision\" is set to NO."));


}

void ACSSinFixSim::setup() {
# line 49 "ACSSinFixSim.pl"
ACSFixSimCore::setup();

                if ( ! int(ArrivingPrecision) ) {
                  fixIn = Fix( ((const char *) InputPrecision) );
		  if ( fixIn.invalid() )
		    Error::abortRun( *this, "Invalid InputPrecision" );
		}
		fixIn.set_rounding( int(RoundFix) );

                out = Fix( ((const char *) OutputPrecision) );
		if ( out.invalid() )
		  Error::abortRun( *this, "Invalid OutputPrecision" );
                out.set_ovflow( ((const char *) OverflowHandler) );
		if ( out.invalid() )
		  Error::abortRun( *this, "Invalid OverflowHandler" );
		out.set_rounding( int(RoundFix) );
}

void ACSSinFixSim::go() {
# line 68 "ACSSinFixSim.pl"
Fix tmp = corona.input%0;
		if ( int(ArrivingPrecision) ) {
			out = Fix(sin (double(tmp)));
		} else {
			fixIn = tmp;
			out = Fix(sin (double(fixIn)));
		}
		checkOverflow(out);
		corona.output%0 << out;
}

// Core prototype instance for known block list
static ACSSin dummy;
static ACSSinFixSim proto(dummy);
static RegisterBlock registerBlock(proto,"SinFixSim");
