static const char file_id[] = "ACSXMGraphFPCGC.pl";
// .cc file generated from ACSXMGraphFPCGC.pl by ptlang
/*
Copyright (c) 1998 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "ACSXMGraphFPCGC.h"
#include "ACSXMGraph.h"
#include "Target.h"

const char *star_nm_ACSXMGraphFPCGC = "ACSXMGraphFPCGC";

const char* ACSXMGraphFPCGC :: className() const {return star_nm_ACSXMGraphFPCGC;}

ISA_FUNC(ACSXMGraphFPCGC,ACSFPCGCCore);

ACSCore* ACSXMGraphFPCGC :: makeNew( ACSCorona & corona_) const { LOG_NEW; return new ACSXMGraphFPCGC(corona_); }

CodeBlock ACSXMGraphFPCGC :: err (
# line 52 "ACSXMGraphFPCGC.pl"
"{\n"
"    fprintf(stderr,\"ERROR: cannot open output file for Xgraph star.\\n\");\n"
"    exit(1);\n"
"}\n");

CodeBlock ACSXMGraphFPCGC :: closeFile (
# line 125 "ACSXMGraphFPCGC.pl"
"for (i = 0; i < $val(numIn); i++) fclose($starSymbol(fp)[i]);\n");

ACSXMGraphFPCGC::ACSXMGraphFPCGC ( ACSCorona & corona_) : ACSFPCGCCore(corona_), corona((ACSXMGraph&)corona_)
{
	addState(numIn.setState("numIn",this,"1","numIn",
# line 17 "ACSXMGraphFPCGC.pl"
A_NONCONSTANT|A_NONSETTABLE));
	addState(resources.setState("resources",this,"STDIO","resources"));
	addState(count.setState("count",this,"0","Samplecounter",
# line 29 "ACSXMGraphFPCGC.pl"
A_NONSETTABLE|A_NONCONSTANT));


}

int ACSXMGraphFPCGC::myExecTime() {
# line 191 "ACSXMGraphFPCGC.pl"
return 6 * int(numIn) + 1;
}

void ACSXMGraphFPCGC::wrapup() {
# line 130 "ACSXMGraphFPCGC.pl"
int i;
		addCode("{\n");
		addCode("int i;\n");

		// close the files
		addCode(closeFile);

		StringList cmd = "( ";

		// save File
		const char* sf = corona.saveFile;
		if (sf != NULL && *sf != 0) {
			for (i = 0; i<int(numIn); i++) {
				cmd << "/bin/cat ";
				cmd << target()->name(); 
				cmd << "_$starSymbol(temp)" << i << " >> ";
				cmd << sf << "; /bin/echo \"\" >> " << sf;
				cmd << "; ";
			}
		}

		cmd << "pxgraph ";

		// put title on command line

		const char* ttl = corona.title;

		if (ttl && *ttl) {
			if (strchr(ttl,'\'')) {
				cmd << "-t \"" << ttl << "\" ";
			}
			else {
				cmd << "-t '" << ttl << "' ";
			}
		}

		const char* opt = corona.options;

		// put options on the command line
		if (opt && *opt) {
			cmd << opt << " ";
		}

		// put file names
		for (i = 0; i < int(numIn); i++) {
			cmd << target()->name() << "_$starSymbol(temp)";
			cmd << i << " ";
		}

		// remove temporary files
		for (i = 0; i < int(numIn); i++) {
			cmd << "; /bin/rm -f " << target()->name();
			cmd << "_$starSymbol(temp)" << i;
		}

		cmd << ") &";
		StringList out = "system(\"";
		out << sanitizeString(cmd) << "\");\n}\n";
		addCode(out);
}

void ACSXMGraphFPCGC::initCode() {
# line 38 "ACSXMGraphFPCGC.pl"
StringList s = "FILE* $starSymbol(fp)[";
		s << corona.input.numberPorts() << "];";
                addDeclaration(s);
                addInclude("<stdio.h>");
		for (int i = 0; i < corona.input.numberPorts(); i++) {
			StringList w = "if(!($starSymbol(fp)[";
			w << i <<  "] = fopen(\"";
			w << target()->name() << "_$starSymbol(temp)";
			w << i << "\",\"w\")))";
			addCode(w);
			addCode(err);
		}
}

void ACSXMGraphFPCGC::setup() {
# line 33 "ACSXMGraphFPCGC.pl"
corona.index = corona.xInit;
		numIn = corona.input.numberPorts();
}

void ACSXMGraphFPCGC::go() {
# line 116 "ACSXMGraphFPCGC.pl"
	{ StringList _str_; _str_ << 
"    if (++$ref(count) >= $val(ignore)) {\n"
;
	 addCode(_str_); }
	  for (int i = 1; i <= int(numIn); i++) {
	{ StringList _str_; _str_ << 
"        fprintf($starSymbol(fp)[" << (i-1) << "],\"%g %g\\n\",\n"
"		 $ref(index),$ref(input#" << (i) << "));\n"
;
	 addCode(_str_); }
	  }
	{ StringList _str_; _str_ << 
"    }\n"
"    $ref(index) += $val(xUnits);"
;
	 addCode(_str_); }

}


const char* ACSXMGraphFPCGC::sanitizeString (StringList s)
{
# line 71 "ACSXMGraphFPCGC.pl"
// quick implementation of a string buffer
			static class Buffer {
			   public:
				Buffer()  { buf = NULL; vsize = psize = 0; }
			// omitting the destructor since GCC 2.5.8 reports an internal
			// compiler error
			//	~Buffer() { if (buf)  free(buf); }

				void initialize() {
				    if (buf)  free(buf), buf = NULL;
				    vsize = psize = 0;
				}

				void append(char c) {
				    if (vsize >= psize)
					    buf = (char*) (buf ? realloc(buf, psize += 1024)
							       : malloc(psize += 1024));
				    buf[vsize++] = c;
				}

				operator const char* ()
				{
				    if (vsize == 0 || buf[vsize-1])
					append('\0');
				    return buf;
				}
			   private:
				// the string buffer
				char* buf;
				// virtual/physical buffer size
				int vsize, psize;
			} buffer;

			buffer.initialize();
				
			for (const char* sp=s; *sp; sp++) {
			    if (*sp == '\"')
				    buffer.append('\\');
			    buffer.append(*sp);
			}
			return (const char*) buffer;
}


// Core prototype instance for known block list
static ACSXMGraph dummy;
static ACSXMGraphFPCGC proto(dummy);
static RegisterBlock registerBlock(proto,"XMGraphFPCGC");
