static const char file_id[] = "ACSXYgraphFPCGC.pl";
// .cc file generated from ACSXYgraphFPCGC.pl by ptlang
/*
Copyright (c) 1998 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "ACSXYgraphFPCGC.h"
#include "ACSXYgraph.h"

const char *star_nm_ACSXYgraphFPCGC = "ACSXYgraphFPCGC";

const char* ACSXYgraphFPCGC :: className() const {return star_nm_ACSXYgraphFPCGC;}

ISA_FUNC(ACSXYgraphFPCGC,ACSFPCGCCore);

ACSCore* ACSXYgraphFPCGC :: makeNew( ACSCorona & corona_) const { LOG_NEW; return new ACSXYgraphFPCGC(corona_); }

CodeBlock ACSXYgraphFPCGC :: err (
# line 37 "ACSXYgraphFPCGC.pl"
"    {\n"
"        fprintf(stderr,\"ERROR: cannot open output file for Xgraph star.\\n\");\n"
"	exit(1);\n"
"    }\n");

CodeBlock ACSXYgraphFPCGC :: closeFile (
# line 99 "ACSXYgraphFPCGC.pl"
"    fclose($starSymbol(fp));\n");

ACSXYgraphFPCGC::ACSXYgraphFPCGC ( ACSCorona & corona_) : ACSFPCGCCore(corona_), corona((ACSXYgraph&)corona_)
{
	setDescriptor("Generates an X-Y plot with the pxgraph program.\nThe X data is on \"xInput\" and the Y data is on \"input\".");
	addState(count.setState("count",this,"0","Samplecounter",
# line 23 "ACSXYgraphFPCGC.pl"
A_NONSETTABLE|A_NONCONSTANT));


}

int ACSXYgraphFPCGC::myExecTime() {
# line 158 "ACSXYgraphFPCGC.pl"
return 6;
}

void ACSXYgraphFPCGC::wrapup() {
# line 104 "ACSXYgraphFPCGC.pl"
// close the files
		addCode(closeFile);

		StringList cmd;
		cmd << "( ";

		// save File
		const char* sf = corona.saveFile;
		if (sf != NULL && *sf != 0) {
			cmd << "/bin/cat ";
			cmd << target()->name(); 
			cmd << "_$starSymbol(temp)" << " >> ";
			cmd << sf << "; /bin/echo \"\" >> " << sf << "; ";
		}

		cmd << "pxgraph ";

		// put title on command line

		const char* ttl = corona.title;

		if (ttl && *ttl) {
			if (strchr(ttl,'\'')) {
				cmd << "-t \"" << ttl << "\" ";
			}
			else {
				cmd << "-t '" << ttl << "' ";
			}
		}

		const char* opt = corona.options;

		// put options on the command line
		if (opt && *opt) {
			cmd << opt << " ";
		}

		// put file name
		cmd << target()->name() << "_$starSymbol(temp)";

		// remove temporary files
		cmd << "; /bin/rm -f " << target()->name();
		cmd << "_$starSymbol(temp)";

		cmd << ") &";
		StringList out = "    system(\"";
		out << sanitizeString(cmd) << "\");\n";
		addCode(out);
}

void ACSXYgraphFPCGC::initCode() {
# line 28 "ACSXYgraphFPCGC.pl"
addDeclaration("    FILE* $starSymbol(fp);");
                addInclude("<stdio.h>");
		StringList w = "    if(!($starSymbol(fp) = fopen(\"";
		w << target()->name() << "_$starSymbol(temp)";
		w << "\",\"w\")))";
		addCode(w);
		addCode(err);
}

void ACSXYgraphFPCGC::go() {
# line 154 "ACSXYgraphFPCGC.pl"
	{ StringList _str_; _str_ << 
"	if (++$ref(count) >= $val(ignore)) \n"
"		fprintf($starSymbol(fp),\"%g %g\\n\",$ref(xInput),$ref(input));"
;
	 addCode(_str_); }

}


const char* ACSXYgraphFPCGC::sanitizeString (StringList s)
{
# line 56 "ACSXYgraphFPCGC.pl"
// quick implementation of a string buffer
			static class Buffer {
			   public:
				Buffer()  { buf = NULL; vsize = psize = 0; }
			// omitting the destructor since GCC 2.5.8 reports an internal
			// compiler error
			//	~Buffer() { if (buf)  free(buf); }

				void initialize() {
				    if (buf)  free(buf), buf = NULL;
				    vsize = psize = 0;
				}

				void append(char c) {
				    if (vsize >= psize)
					    buf = (char*) (buf ? realloc(buf, psize += 1024)
							       : malloc(psize += 1024));
				    buf[vsize++] = c;
				}

				operator const char* ()
				{
				    if (vsize == 0 || buf[vsize-1])
					append('\0');
				    return buf;
				}
			   private:
				// the string buffer
				char* buf;
				// virtual/physical buffer size
				int vsize, psize;
			} buffer;

			buffer.initialize();
				
			for (const char* sp=s; *sp; sp++) {
			    if (*sp == '\"')
				    buffer.append('\\');
			    buffer.append(*sp);
			}
			return (const char*) buffer;
}


// Core prototype instance for known block list
static ACSXYgraph dummy;
static ACSXYgraphFPCGC proto(dummy);
static RegisterBlock registerBlock(proto,"XYgraphFPCGC");
